/*	
	ImageView - version 2.6
	26 July, 2009
	Written by Harry Whitfield (g6auc@arrl.net)
	Interface by Ricky Romero (rlr@ricky-romero.com)
	Code and Images Copyright 2004-2009 by Harry Whitfield and Ricky Romero
	Widget spawning code is based on code by Arlo Rose.
	Thanks go to Cicerone Pavaloi for help in improving the scrolling and rotation code.
*/

/*global changeImage, image, imageType, main_window, pause, setImage,
		 theTimer, writePlist, bkgd, bottom, bottomSmall, close, eprint, getImageNames,
		 hsb, leftSide, lowerLeft, lowerLeftSmall, lowerRight, lowerRightSmall,
		 mimg, rightSide, rimg, timer1, top, upperLeft, upperRight, vsb, back, forward, frame,
		 main_frame, open, setPictureFrameVitality, spawn, status, statusShadow, wrench,
		 count, escapePath, getFileInfo, getProcessTable, killProcess, lprint, theSpawnPos
*/

/*members PI, abs, altKey, anchorPref, anchorXPref, anchorYPref, 
    arrowsPref, aspectRatioPref, atan2, availHeight, availLeft, availTop, 
    availWidth, colorize, contextMenuItems, copy, cos, createDirectory, 
    cyclePref, data, defaultValue, description, detailsPref, 
    editorParamsPref, editorPref, editorRevertPref, enabled, event, 
    focusPref, folderPref, font, frameColor, framePref, fromCharCode, 
    getDirectoryContents, hOffset, hRegistrationPoint, height, heightPref, 
    hidden, hideButtonsPref, imageMaskPref, imagePref, imageScalePref, 
    indexOf, interval, isDirectory, itemExists, konfabulatorWindowLevel, 
    konfabulatorWindowOpacity, lastIndexOf, length, match, maxHeightPref, 
    maxWidthPref, modePref, move, moveToTrash, namePref, newChildPref, 
    newSpawnPref, onMouseDown, onMouseDrag, onMouseUp, onTimerFired, 
    opacity, open, openFileInApplication, openSpawn, option, optionValue, 
    oversizePref, platform, random, readFile, reload, remove, reset, 
    restartListPref, reveal, rotation, rotationPref, round, scrollBarsPref, 
    scrollModePref, shiftKey, sin, size, sort, spawnKonFilePref, split, 
    sqrt, src, srcHeight, srcWidth, subFolderPref, substr, substring, 
    temporaryFolder, thumbColor, ticking, timerPref, title, toLowerCase, 
    tooltip, tooltipPref, type, vOffset, vRegistrationPoint, value, 
    versionPref, visible, widgetDataFolder, width, widthPref, writeFile, x, 
    y
*/

var versionPref = "2.6";
		
		var resPath ;		// Path to Resources folder - set below
		var spawnPath;		// Path to Spawns folder - set below

		var spawnResPath;	// Spawn's Path to Resources folder - set below
		
		var spawnKonFile;	// Filename of .kon file of spawned widget - set below
		var widgetName;		// Name of widget - set below
		var children = 0;	// Count of number of children
		
		var systemPlatform = system.platform;
		//var systemPlatform = "windows";	// for testing windows code on the Macintosh

		var left  = true;
		var right = false;

		var upper = true;
		var lower = false;
		
		var magnification =  4;		// magnification factor with lens button
		var border        = 10;		// border size
			
		var wDelta 		  = 40;		// was 30
		var hDelta		  = 40;		// was 40
		
		var scrollMode    = (preferences.scrollModePref.value == "1");
		var scrollBars    = (preferences.scrollBarsPref.value == "1");
		var navArrows     = (preferences.arrowsPref.value     == "1");
		var useSubFolders = (preferences.subFolderPref.value  == "1");
		var oversizeMag   = Number(preferences.oversizePref.value) + 1;
		var thumbColor    = preferences.thumbColor.value;
		
		var displayType = '.' + preferences.imageMaskPref.value.split(' ')[0];

		var mouseWithin = false;
		var timer   = 0;
		var enlargedFlag = false;
		var imageName = "";
		var cyclePref  = 0;
		var folderPref = "";
		var oldFolderPref = "";
		var oldUseSubFolders = useSubFolders;
		var oldDisplayType = displayType;

		var slideShow = false;
		var slides = [];
		var gSlide = 0 - 1;
		var gPrevSlide = 0 -1;
		var listSep = "<<<::>>>";
		var hasFocus = true;
		
		var halfWinWidth;
		var halfWinHeight;
		var halfWidth;
		var halfHeight;

		var frameOpacity;
		var newRotation; 
		
		var anchorX = 0;
		var anchorY = 0;

		var downX, downY, downRotation, downAngle, scrollX, scrollY, altKey = false;
		
		var section = 0;
		
		// eprint("section: " + (section++)); 
		
		function deleteSlide(path)
		{
			if (theTimer.ticking) { beep(); return; }

			beep();
			var result = alert(widgetName + ": You are about to delete a slide.", "Cancel","Delete");
			if (result == "2")
			{	
				filesystem.moveToTrash(path);
			}
		}

		function setMode(pname)
		{
			imageName = pname;
		}
		
		function setTooltip(pname)
		{
			var tooltip, type;
			
			if (preferences.tooltipPref.value == "1") { image.tooltip = ""; }
			else
			{
				tooltip = widgetName + "\nTo change the view, drag an image onto me.";
				
				if (preferences.detailsPref.value == "1")
				{
					tooltip += "\n\nSubtitle: " + pname;
					type = imageType(image.src);
					if (type !== "")
					{
						type = type.substring(1);
						tooltip += "\nType:   " + type;
						tooltip += "\nWidth:  " + image.srcWidth;
						tooltip += "\nHeight: " + image.srcHeight;
					}
				}
				image.tooltip = tooltip;
			}
		}

		function deleteImage()
		{
			var imagePath;
			
			if (slideShow) { deleteSlide(image.src); return; }
			
			beep();
			var userImage = preferences.imagePref.value;
			if (userImage == "defaultImage.png") { return; }
			var result = alert(widgetName + ": You are about to delete the stored image.", "Cancel","Delete");
			if (result == "2")
			{
				imagePath = system.widgetDataFolder + "/" + userImage;
				
				filesystem.moveToTrash(imagePath);
				
				preferences.imagePref.value = "defaultImage.png";
				preferences.namePref.value  = "ImageTitle";
				savePreferences();
				writePlist(spawnKonFile);
				
				suppressUpdates();
				setMode(preferences.namePref.value);
				setImage(preferences.imagePref.value);
				setTooltip(preferences.namePref.value);
				resumeUpdates();
			}
		}

		function openSlide(path)
		{
			if ((preferences.editorRevertPref.value == "1") || (preferences.editorPref.value === ""))	// use default application
			{
				filesystem.open(path);
			}
			else if (systemPlatform == 'macintosh')														// Macintosh: open in user selected application
			{
				filesystem.openFileInApplication(preferences.editorPref.value, path);
			}
			else																						// Windows: open in user selected application
			{
				filesystem.openFileInApplication(preferences.editorPref.value, path, preferences.editorParamsPref.value);
			}
		}

		function openImage()
		{
			if (slideShow) { openSlide(image.src); return; }
			
			var userImage = preferences.imagePref.value;
			if (userImage == "defaultImage.png") { beep(); return; }
			var imagePath = system.widgetDataFolder + "/" + userImage;
			openSlide(imagePath);
		}

		function onWrench()
		{
			if (system.event.altKey)			//	optionKeyDown(system.event.modifiers)
			{
				deleteImage();
			}
			else if (system.event.shiftKey)		// shiftKeyDown(system.event.modifiers)
			{
				filesystem.reveal(image.src);
			}
			else
			{
	 			openImage();
			}
		}
		
		function flash(image)
		{
			for (var i = 0; i < 2; i += 1)
			{
				image.opacity=255;
				sleep(100);
				image.opacity=128;
				sleep(100);
			}
			image.opacity=255;
			sleep(100);
		}

		// eprint("section: " + (section++)); 
 
		function onPause() {
			if (system.event.altKey) {
				if (preferences.focusPref.value == "1") {
					preferences.focusPref.value = "0";
				} else {
					preferences.focusPref.value = "1";
				}
			}
			else if (slideShow)
			{
				theTimer.ticking = ! theTimer.ticking;
				
				main_window.contextMenuItems[4].enabled = ! theTimer.ticking;		// delete slide

				if (theTimer.ticking)
				{
					pause.src = "Resources/Images/Pause.png";
					pause.tooltip = "Pause the slide show. Alt-click to toggle the cycle mode.";
				}
				else
				{
					pause.src = "Resources/Images/Play.png";
					pause.tooltip = "Continue the slide show. Alt-click to toggle the cycle mode.";
				}
			}
			else { beep(); }
		}

		function changeSpeed(faster) {
			var times = preferences.cyclePref.optionValue;
			var time  = preferences.cyclePref.value;
			var found = -1;
			for (var i = 0; i < times.length; i += 1) {
				if (time == times[i]) { found = i; }
			}
			if (faster && (found > 1)) {
				preferences.cyclePref.value = preferences.cyclePref.optionValue[found - 1];
			} else if (!faster && (found > 0) && (found < times.length - 1)) {
				preferences.cyclePref.value = preferences.cyclePref.optionValue[found + 1];
			}
			cyclePref = Number(preferences.cyclePref.value);
			if (cyclePref > 0) {
				theTimer.interval = cyclePref;
				theTimer.reset();
			} else {
				theTimer.ticking = false;
			}
		}

		function nextSlide() {
			if (slideShow) {
				if (system.event.altKey) {
					changeSpeed(true);
				} else {
					theTimer.reset();
					changeImage(true, true);	// changeImage(forward, force)
				}
			}
			else { beep(); }
		}

		function prevSlide() {
			if (slideShow) {
				if (system.event.altKey) {
					changeSpeed(false);
				} else {
					theTimer.reset();
					changeImage(false, true);	// changeImage(backward, force)
				}
			}
			else { beep(); }
		}

		function saveAnchorPoint(image)
		{
			var anchorPref = preferences.anchorPref.value;

			switch (anchorPref)
			{
				case "Top Left of Image":
					anchorX = main_window.hOffset + (main_window.width  >> 1) - image.hRegistrationPoint;
					anchorY = main_window.vOffset + (main_window.height >> 1) - image.vRegistrationPoint;
					break;
				
				case "Top Right of Image":
					anchorX = main_window.hOffset + (main_window.width  >> 1) + image.hRegistrationPoint;
					anchorY = main_window.vOffset + (main_window.height >> 1) - image.vRegistrationPoint;
					break;
					
				case "Bottom Left of Image":
					anchorX = main_window.hOffset + (main_window.width  >> 1) - image.hRegistrationPoint;
					anchorY = main_window.vOffset + (main_window.height >> 1) + image.vRegistrationPoint;
					break;
					
				case "Bottom Right of Image":
					anchorX = main_window.hOffset + (main_window.width  >> 1) + image.hRegistrationPoint;
					anchorY = main_window.vOffset + (main_window.height >> 1) + image.vRegistrationPoint;
					break;

				case "Center of Image":
					anchorX = main_window.hOffset + (main_window.width  >> 1);
					anchorY = main_window.vOffset + (main_window.height >> 1);
					break;
					
				default:
					anchorX = 72;
					anchorY = 36;
					break;
			}
			preferences.anchorXPref.value = String(anchorX);
			preferences.anchorYPref.value = String(anchorY);
		}

		function anchorWindow(image)
		{
			var anchorPref = preferences.anchorPref.value;
			switch (anchorPref)
			{
				case "None":
					break;
				
				case "Top Left of Screen":
					main_window.hOffset = 10 + screen.availLeft - (main_window.width  >> 1) + image.hRegistrationPoint;
					main_window.vOffset = 13 + screen.availTop  - (main_window.height >> 1) + image.vRegistrationPoint;
					break;
				
				case "Top Right of Screen":
					main_window.hOffset = -10 + screen.availLeft + screen.availWidth - (main_window.width  >> 1) - image.hRegistrationPoint;
					main_window.vOffset =  13 + screen.availTop - (main_window.height >> 1) + image.vRegistrationPoint;
					break;
					
				case "Bottom Left of Screen":
					main_window.hOffset = 10 + screen.availLeft - (main_window.width  >> 1) + image.hRegistrationPoint;
					main_window.vOffset = screen.availTop  + screen.availHeight - (main_window.height >> 1) - image.vRegistrationPoint;
					break;
					
				case "Bottom Right of Screen":
					main_window.hOffset = -10 + screen.availLeft + screen.availWidth - (main_window.width  >> 1) - image.hRegistrationPoint;
					main_window.vOffset = screen.availTop  + screen.availHeight - (main_window.height >> 1) - image.vRegistrationPoint;
					break;
					
				case "Center of Screen":
					main_window.hOffset = screen.availLeft + (screen.availWidth  >> 1) - (main_window.width  >> 1);
					main_window.vOffset = screen.availTop  + (screen.availHeight >> 1) - (main_window.height >> 1);
					break;

				case "Top Left of Image":
					main_window.hOffset = anchorX - (main_window.width  >> 1) + image.hRegistrationPoint;
					main_window.vOffset = anchorY - (main_window.height >> 1) + image.vRegistrationPoint;
					break;
				
				case "Top Right of Image":
					main_window.hOffset = anchorX - (main_window.width  >> 1) - image.hRegistrationPoint;
					main_window.vOffset = anchorY - (main_window.height >> 1) + image.vRegistrationPoint;
					break;
					
				case "Bottom Left of Image":
					main_window.hOffset = anchorX - (main_window.width  >> 1) + image.hRegistrationPoint;
					main_window.vOffset = anchorY - (main_window.height >> 1) - image.vRegistrationPoint;
					break;
					
				case "Bottom Right of Image":
					main_window.hOffset = anchorX - (main_window.width  >> 1) - image.hRegistrationPoint;
					main_window.vOffset = anchorY - (main_window.height >> 1) - image.vRegistrationPoint;
					break;

				case "Center of Image":
					main_window.hOffset = anchorX - (main_window.width  >> 1);
					main_window.vOffset = anchorY - (main_window.height >> 1);
				break;
			}
		}

		function setFrameColor(color)
		{
			upperLeft.colorize=color;
			top.colorize=color;
			upperRight.colorize=color;
			rightSide.colorize=color;
			leftSide.colorize=color;
			lowerRight.colorize=color;
			bottom.colorize=color;
			lowerLeft.colorize=color;
			lowerRightSmall.colorize=color;
			bottomSmall.colorize=color;
			lowerLeftSmall.colorize=color;
		}

		function updatePrefs(saveAP)
		{
			var names;
			
			var minW = 156;
			var minH =  32;
			
			if (saveAP) { saveAnchorPoint(bkgd); }

			oversizeMag   = Number(preferences.oversizePref.value) + 1;
			
			var maxW = oversizeMag*screen.availWidth;
			var maxH = oversizeMag*screen.availHeight;
			
			var width = preferences.widthPref.value;
			if (width !== "")
			{
				width = parseInt(width, 10);
				if (isNaN(width)) { width = minW; }
				if (width < minW) { width = minW; }
				if (width > maxW) { width = maxW; }
				preferences.widthPref.value = width;
			}
			
			var height = preferences.heightPref.value;
			if (height !== "")
			{
				height = parseInt(height, 10);
				if (isNaN(height)) { height = minH; }
				if (height < minH) { height = minH; }
				if (height > maxH) { height = maxH; }
				preferences.heightPref.value = height;
			}
			
			var maxWidth = preferences.maxWidthPref.value;
			if (maxWidth !== "")
			{
				maxWidth = parseInt(maxWidth, 10);
				if (isNaN(maxWidth)) { maxWidth = ""; }
				else
				{
					if (maxWidth < minW) { maxWidth = minW; }
					if (maxWidth > maxW) { maxWidth = maxW; }
				}
				preferences.maxWidthPref.value = maxWidth;
			}
			
			var maxHeight = preferences.maxHeightPref.value;
			if (maxHeight !== "")
			{
				maxHeight = parseInt(maxHeight, 10);
				if (isNaN(maxHeight)) { maxHeight = ""; }
				else
				{
					if (maxHeight < minH) { maxHeight = minH; }
					if (maxHeight > maxH) { maxHeight = maxH; }
				}
				preferences.maxHeightPref.value = maxHeight;
			}
			
			var rotation = parseInt(preferences.rotationPref.value, 10);
			if (isNaN(rotation)) { rotation = 0; }
			if (rotation ==  360) { preferences.framePref.value = "0"; }
			if (rotation == -360) { preferences.framePref.value = "1"; }
			if (rotation > 359) { rotation = 0; }
			if (rotation < -359) { rotation = 0; }
			preferences.rotationPref.value = rotation;
			newRotation = Number(preferences.rotationPref.value);
			
			scrollMode = (preferences.scrollModePref.value == "1");
			scrollBars = (preferences.scrollBarsPref.value == "1");
			navArrows  = (preferences.arrowsPref.value     == "1");
			
			hsb.thumbColor = vsb.thumbColor = preferences.thumbColor.value;
			
			setFrameColor(preferences.frameColor.value);
			
			magnification = Number(preferences.imageScalePref.value)/ 100;
			eprint('magnification=' + magnification);
			
			if (!saveAP)
			{
				anchorX = Number(preferences.anchorXPref.value);
				anchorY = Number(preferences.anchorYPref.value);

				eprint('restored anchorX=' + anchorX);
				eprint('restored anchorY=' + anchorY);
			}

			setMode(preferences.namePref.value);
			setImage(preferences.imagePref.value);
			setTooltip(preferences.namePref.value);

			cyclePref  = Number(preferences.cyclePref.value);
			eprint('cyclePref=' + cyclePref);
			
			theTimer.ticking  = false;
			if (cyclePref > 0) { theTimer.interval = cyclePref; }
			
			folderPref = preferences.folderPref.value;
			useSubFolders = (preferences.subFolderPref.value == "1");
			displayType = '.' + preferences.imageMaskPref.value.split(' ')[0];
			
			if ((cyclePref > 0) && (folderPref !== ""))
			{
				if ((oldFolderPref === "") || (folderPref != oldFolderPref) ||
				    (useSubFolders != oldUseSubFolders) || (displayType != oldDisplayType))
				{
					names = getImageNames(folderPref, useSubFolders);
					if (names !== "")
					{
						slides = names.split(listSep);
						oldFolderPref = folderPref;
						oldUseSubFolders = useSubFolders;
						oldDisplayType = displayType;
					}
					else 
					{
						beep();
						alert(widgetName + ": The Image Directory is invalid, or does not contain any images of the selected type.");
					}
				}
			}
			else if ((cyclePref > 0) && (folderPref === ""))
			{
				beep();
				alert(widgetName + ": The Image Directory is invalid.");
			}
			
			slideShow = ((cyclePref > 0) && (slides.length > 0));
			
			eprint('slideShow=' + slideShow);
			
			theTimer.ticking = slideShow;
			
			if (slideShow) { changeImage(true, false); }
			
			pause.src = "Resources/Images/Pause.png";
			pause.tooltip = "Pause the slide show.";

			timer1.ticking = false;
			
			main_window.contextMenuItems[0].enabled = slideShow;	// next slide
			main_window.contextMenuItems[1].enabled = slideShow;	// previous slide
			main_window.contextMenuItems[2].enabled = slideShow;	// find
			main_window.contextMenuItems[3].enabled = slideShow;	// open
			main_window.contextMenuItems[4].enabled = false;		// delete

			savePreferences();
		}

		function min(a, b) { if (a < b) { return a; } else { return b; } }

		function stringWidth(string, fontname, fontsize)	// by Perry Clarke 6 May 2004
		{
			var tmpText = new Text();
			var width;
			
			tmpText.opacity = 0;
			tmpText.font = fontname;
			tmpText.size = fontsize;
			tmpText.data = string;
			
			//updateNow();				// temporary patch K 1.6
		
			width = tmpText.width;
			//delete tmpText;
			return width;
		}

		function set(object, left, x, upper, y, w, h)
		{
			object.hOffset = halfWinWidth;
			object.vOffset = halfWinHeight;
			object.hRegistrationPoint = (left  ? - x + halfWidth  : - halfWidth  - x);
			object.vRegistrationPoint = (upper ? - y + halfHeight : - halfHeight - y);  
			object.rotation = 0;
			
			if (w !== 0) { object.width  = w; }
			if (h !== 0) { object.height = h; }
			object.opacity = frameOpacity;
		}

		function reSize(big)
		{
			eprint('-------------reSize--------------------');
			
			var newWidth    = preferences.widthPref.value;
			var newHeight   = preferences.heightPref.value;
				newRotation = Number(preferences.rotationPref.value);	// needed ??
			var focus       = (close.opacity !== 0);
			
			eprint("reSize:image.src=" + image.src);
			eprint("reSize:image.srcWidth=" + image.srcWidth);
			eprint("reSize:image.srcHeight=" + image.srcHeight);

			var originalWidth  = Number(image.srcWidth);	// original width
			var originalHeight = Number(image.srcHeight);	// original height
			
				
			if (isNaN(originalWidth) || isNaN(originalHeight))
			{
				eprint("reSize: Image " + image.src + " has invalid size data.");
				originalWidth  = 320;
				originalHeight = 240;
				image.src = 'Resources/Images/defaultImage.png';
			}
			
			if ((originalWidth === 0) || (originalHeight === 0))
			{
				eprint("reSize: Image " + image.src + " has invalid size data.");
				originalWidth  = 320;
				originalHeight = 240;
				image.src = 'Resources/Images/defaultImage.png';
			}

			var width;
			var height;
			var aspectRatio;

			if ((newWidth !== "") && (newHeight !== ""))		// user specified width and height
			{
				width  = Number(newWidth);
				height = Number(newHeight);
				aspectRatio = Number(width / height);
			}
			else if ((newWidth === "") && (newHeight === ""))	// user specified neither width nor height
			{
				width  = Number(originalWidth);
				height = Number(originalHeight);
				aspectRatio = Number(width / height);
			}
			else if ((newWidth !== "") && (newHeight === ""))	// user specified width only
			{
				width  = Number(newWidth);
				aspectRatio = Number(originalWidth / originalHeight);
				height = Math.round(width / aspectRatio);
			}
			else if ((newWidth === "") && (newHeight !== ""))	// user specified height only
			{
				height = Number(newHeight);
				aspectRatio = Number(originalWidth / originalHeight);
				width = Math.round(height * aspectRatio);
			}
			else { return; }

			if (preferences.aspectRatioPref.value != "0")
			{
				aspectRatio = Number(4 / 3);
				height = Number(width / aspectRatio);
			}
			
			var minW = 156;
			var minH =  32;
			
			if (width < minW) 
			{
				width  = minW;
				height = Math.round(width / aspectRatio);
			}
			
			if (height < minH) 
			{
				height = minH;
				width = Math.round(height * aspectRatio);
			}

			if (big)	// apply magnification factor
			{
				eprint('magnification=' + magnification);
				
				width  = Math.round( magnification * width);
				height = Math.round( magnification * height);
			}

			var pi = Math.PI;
			var theta = pi * newRotation / 180;
			
			var fullWidth  = wDelta - 0 + width;  eprint('fullWidth= ' + fullWidth);
			var fullHeight = hDelta - 0 + height; eprint('fullHeight=' + fullHeight);
			
			var rotWidth  = Math.round(fullWidth*Math.abs(Math.cos(theta)) + fullHeight*Math.abs(Math.sin(theta)));
			var rotHeight = Math.round(fullWidth*Math.abs(Math.sin(theta)) + fullHeight*Math.abs(Math.cos(theta)));
			
			eprint('rotWidth= '  + rotWidth);
			eprint('rotHeight= ' + rotHeight);

			var maxWidth  = oversizeMag*screen.availWidth  - border - border - 10;
			if (preferences.maxWidthPref.value !== "") { maxWidth = min(maxWidth, Number(preferences.maxWidthPref.value)); }
			
			var maxHeight = oversizeMag*screen.availHeight - border - border - 10;
			if (preferences.maxHeightPref.value !== "") { maxHeight = min(maxHeight, Number(preferences.maxHeightPref.value)); }
			
			maxWidth  = Math.round(maxWidth  * fullWidth  / rotWidth );
			maxHeight = Math.round(maxHeight * fullHeight / rotHeight);
			
			eprint('maxWidth= '  + maxWidth);
			eprint('maxHeight= ' + maxHeight);

			if (width > maxWidth) 
			{
				width  = maxWidth;
				height = Math.round(width / aspectRatio);
			}
			
			if (height > maxHeight) 
			{
				height = maxHeight;
				width = Math.round(height * aspectRatio);
			}
			
			if (width < minW)
			{
				width = minW;
				height = Math.round(width / aspectRatio);
			}
			
			if (height < minH)
			{
				height = minH;
				width = Math.round(height * aspectRatio);
			}

			width  = width  + (width  % 2); eprint('width= ' + width);	// make width and height even
			height = height + (height % 2); eprint('height=' + height);
			
			halfWidth  = width  >> 1;  eprint('halfWidth= ' + halfWidth);
			halfHeight = height >> 1;  eprint('halfHeight=' + halfHeight);

			fullWidth  = wDelta - 0 + width;  eprint('fullWidth= ' + fullWidth);
			fullHeight = hDelta - 0 + height; eprint('fullHeight=' + fullHeight);

//			var winWidth  = Math.round(fullWidth*Math.abs(Math.cos(theta)) + fullHeight*Math.abs(Math.sin(theta)));
//			var winHeight = Math.round(fullWidth*Math.abs(Math.sin(theta)) + fullHeight*Math.abs(Math.cos(theta)));
			
			var diagonal = function (a, b) { return Math.round(Math.sqrt(a*a + b*b)); };

			var winWidth  = diagonal(fullWidth, fullHeight);
			var winHeight = winWidth;

			winWidth  = winWidth  + (winWidth  % 2) + 40;
			winHeight = winHeight + (winHeight % 2) + 40;
			
			main_window.width  = winWidth;	eprint('main_window.width= ' + main_window.width);
			main_window.height = winHeight;	eprint('main_window.height=' + main_window.height);

			halfWinWidth  = winWidth  >> 1;	eprint('halfWinWidth= ' + halfWinWidth);
			halfWinHeight = winHeight >> 1;	eprint('halfWinHeight=' + halfWinHeight);

			frameOpacity = 255; if (preferences.framePref.value != "0") { frameOpacity = 0; }

		

			rimg.hOffset = rimg.vOffset = mimg.hOffset = mimg.vOffset = halfWinHeight;

			main_frame.hOffset = halfWinWidth;
			main_frame.vOffset = halfWinHeight;
           	main_frame.hRegistrationPoint = halfWinWidth;
           	main_frame.vRegistrationPoint = halfWinHeight;
       		main_frame.width  = winWidth;
			main_frame.height = winHeight;
           	main_frame.rotation = newRotation;

			bkgd.hOffset = halfWinWidth;
			bkgd.vOffset = halfWinHeight;
           	bkgd.hRegistrationPoint = halfWidth;
           	bkgd.vRegistrationPoint = halfHeight + 8;
       		bkgd.width  = width;
			bkgd.height = height;
           	bkgd.rotation = 0;

			frame.hOffset = halfWinWidth;
			frame.vOffset = halfWinHeight;
           	frame.hRegistrationPoint = halfWidth;
           	frame.vRegistrationPoint = halfHeight + 8;
       		frame.width  = width;
			frame.height = height;
           	frame.rotation = 0;
           	
			hsb.hOffset = halfWinWidth;
			hsb.vOffset = halfWinHeight;
           	hsb.hRegistrationPoint = halfWidth;
           	hsb.vRegistrationPoint = 8 + 15 - halfHeight;
       		hsb.width  = width - 15;
           	hsb.rotation = 0;

			vsb.hOffset = halfWinWidth;
			vsb.vOffset = halfWinHeight;
           	vsb.hRegistrationPoint = 15 - halfWidth;
           	vsb.vRegistrationPoint = halfHeight + 8;
       		vsb.height = height - 15;
           	vsb.rotation = 0;

        	image.width  = width;
			image.height = height;

			hsb.opacity = vsb.opacity = 0;
			
			if (scrollMode)
			{
				if (frame.width  < image.srcWidth)     { image.width  = image.srcWidth;    }
				if (frame.height < image.srcHeight)    { image.height = image.srcHeight;   }
				if (scrollBars) { hsb.opacity  = vsb.opacity = 255; } 
			}

           	image.reload();

           	setPictureFrameVitality(image);

			set(upperLeft,   left, -13, upper, -19,          0,           0);
			set(top,         left,   8, upper, -19, width - 15,           0);
			set(upperRight,  right, -7, upper, -19,          0,           0);
			
			set(leftSide,    left, -13, upper,   3,          0, height - 18);
			set(rightSide,   right, -7, upper,   3,          0, height - 18);
 			
 			set(lowerLeft,   left, -13, lower, -15,          0,           0);
 			set(bottom,      left,   8, lower, -15, width - 15,           0);
			set(lowerRight,  right, -7, lower, -15,          0,           0);
			
  			if (! focus) { lowerLeft.opacity = 0; }
			if (! focus) { bottom.opacity = 0; }
          	if (! focus) { lowerRight.opacity = 0; }

   			set(lowerLeftSmall,   left, -13, lower, -15,          0,      0);
			set(bottomSmall,      left,   8, lower, -14, width - 15,      0);
 			set(lowerRightSmall,  right, -7, lower, -15,          0,      0);
			
  			if (focus) { lowerLeftSmall.opacity = 0; }
			if (focus) { bottomSmall.opacity = 0; }
           	if (focus) { lowerRightSmall.opacity = 0; }

          	set(open,   left,    8, lower, -9, 0, 0);
			open.opacity = 0;
			if (focus) { open.opacity = 255; }
			
          	set(wrench, left,   28, lower, -9, 0, 0);
			wrench.opacity = 0;
			if (focus) { wrench.opacity = 255; }

          	set(pause, left,   48, lower, -9, 0, 0);
			pause.opacity = 0;
			if (focus) { pause.opacity = 255; }

          	set(back, left,   68, lower, -9, 0, 0);
			back.opacity = 0;
			if (focus) { back.opacity = 255; }

          	set(forward,  right, -68, lower, -9, 0, 0);
			forward.opacity = 0;
			if (focus) { forward.opacity = 255; }
			
          	set(close,  right, -48, lower, -9, 0, 0);
			close.opacity = 0;
			if (focus) { close.opacity = 255; }
			
         	set(spawn,  right, -28, lower, -9, 0, 0);
 			spawn.opacity = 0;
 			if (focus) { spawn.opacity = 255; }

			statusShadow.hOffset = halfWinWidth;
			statusShadow.vOffset = halfWinHeight;
           	statusShadow.hRegistrationPoint = 0;
           	statusShadow.vRegistrationPoint = 8 - halfHeight - 8;
       		statusShadow.width  = width;
           	statusShadow.rotation = 0;

          	statusShadow.opacity = 0; if (focus) { statusShadow.opacity = 255; }

 			status.hOffset = halfWinWidth;
			status.vOffset = halfWinHeight;
           	status.hRegistrationPoint = 0;
           	status.vRegistrationPoint = 8 - halfHeight - 9;
       		status.width  = width;
           	status.rotation = 0;

          	status.opacity = 0; if (focus) { status.opacity = 255; }

          	var sWidth = stringWidth(imageName, "Futura Medium", 9);
            var bWidth = width - 160;

	        if (sWidth <= bWidth) { status.data = statusShadow.data = imageName; }
            else { status.data = statusShadow.data = ""; }
            
            anchorWindow(bkgd);
		}

		function enlarge()
		{
			saveAnchorPoint(bkgd);
			
			enlargedFlag = true;
			reSize(enlargedFlag);
		}

		function reduce()
		{
			saveAnchorPoint(bkgd);
			
			enlargedFlag = false;
			reSize(enlargedFlag);
		}
		
		function openMouseUp()
		{
			if (enlargedFlag) { reduce(); } else { enlarge(); }
		}

		function onMouseOver(flag)
		{			
			if (preferences.timerPref.value != "0")
			{
				timer = 0;
				mouseWithin = flag;
				if (flag) { timer1.ticking = true; }
			}
		}

		function xtn(s)
		{
			var ext;
			var idx = s.lastIndexOf(".");
			if (idx >=0 )
			{
				ext = s.substring(idx);
				if (ext.length > 1) { return ext; }
			}
			return "";
		}

		function isImage(path)
		{
			var result, fileData, item, stype, itype, dtype, xtype;
			
			// PNG image data, 412 x 237, 8-bit/color RGBA, non-interlaced
			// JPEG image data, JFIF standard 1.01, resolution (DPI), 72 x 72
			// GIF image data, version 89a, 600 x 62
			// TIFF image data, big-endian
			// PDF document, version 1.3
			// ms-windows icon resource - 6 icons, 32x32, 256-colors
		
			if (systemPlatform == "macintosh")	// files on the macintosh may not have extensions
			{
				result = getFileInfo(path);
				fileData = result.substr(path.length + 2);
				item = fileData.split(" ", 3);				// JPEG image data, JFIF
				if (item.length < 3) { return false; }
				stype = item[0];
				itype = item[1];
				dtype = item[2];
				if (stype == "PDF") { return true; }
				if ((stype == "ms-windows") && (itype == "icon") && (dtype == "resource")) { return true; }
				dtype = dtype.substring(0, 4);
				if ((itype == "image") && (dtype == "data"))
				{
					if ((stype == "PNG") || (stype == "JPEG") || (stype == "GIF") || (stype == "TIFF"))  { return true; }
				}
				return false;
			}
			xtype = xtn(path).toLowerCase();
			return ((xtype == '.png') || (xtype == '.jpg') || (xtype == '.gif') || (xtype == '.tif')  || (xtype == '.ico'));
		}
		
		function imageType(path)
		{
			var result, fileData, item, stype, itype, dtype, xtype;
			
			// PNG image data, 412 x 237, 8-bit/color RGBA, non-interlaced
			// JPEG image data, JFIF standard 1.01, resolution (DPI), 72 x 72
			// GIF image data, version 89a, 600 x 62
			// TIFF image data, big-endian
			// PDF document, version 1.3
			// ms-windows icon resource - 6 icons, 32x32, 256-colors
		
			if (systemPlatform == "macintosh")
			{
				result = getFileInfo(path);
				fileData = result.substr(path.length + 2);
				item = fileData.split(" ", 3);				// JPEG image data, JFIF
				if (item.length < 3) { return ""; }
				stype = item[0];
				itype = item[1];
				dtype = item[2];
				if (stype == "PDF") { return ".pdf"; }
				if ((stype == "ms-windows") && (itype == "icon") && (dtype == "resource")) { return ".ico"; }
				dtype = dtype.substring(0,4);
				if ((itype == "image") && (dtype == "data"))
				{
					if (stype == "PNG")   { return ".png"; }
					if (stype == "JPEG")  { return ".jpg"; }
					if (stype == "GIF")   { return ".gif"; }
					if (stype == "TIFF")  { return ".tif"; }
				}
				return "";
			}
			xtype = xtn(path).toLowerCase();
			if ((xtype == '.png') || (xtype == '.jpg') || (xtype == '.gif') || (xtype == '.tif')  || (xtype == '.ico')) { return xtype; }
			return "";
		}

		function setImage(userImage)
		{
			var imagePath = system.widgetDataFolder + '/' + userImage;
			
			if (userImage == "defaultImage.png") { imagePath = 'Resources/Images/' + userImage; }
			
			if (!isImage(imagePath))
			{
				userImage = "defaultImage.png";
				imagePath = 'Resources/Images/' + userImage;

				preferences.imagePref.value = userImage;
				preferences.namePref.value  = "ImageTitle";
				savePreferences();
				writePlist(spawnKonFile);
			}

			if (filesystem.itemExists(imagePath))
			{
				try
				{
					image.src = imagePath;
					reSize(enlargedFlag);
				}
				catch(e)
				{
				
				}
			}
		}

 		function dragDropped(image)
		{
			var path, userImage, oldImagePath, idx, imagePath;
			
			eprint("--------------------------------------------");
			
			var n = system.event.data.length;
			var dropData = [];
			for (var i = 0; i < n; i += 1) { dropData[i] = system.event.data[i]; }
			
			flash(image);

			var dropType = dropData[0];

			eprint(dropType + ":");

			if (dropType == "filenames")
			{
				n = 2; // accept one file only
				
				for (i = 1; i < n; i += 1)
				{
					path = dropData[i];

					eprint("-------------------");
					eprint('Path: ' + path);
					
					if (isImage(path))	// we have a new image so delete the old image
					{
						userImage = preferences.imagePref.value;
						if (userImage != "defaultImage.png")
						{
							oldImagePath = system.widgetDataFolder + "/" + userImage;
							filesystem.moveToTrash(oldImagePath);
						}

						idx = path.lastIndexOf("/");
						userImage = path.substring(idx+1);
						imagePath = system.widgetDataFolder + '/' + userImage;
						
						filesystem.copy( path, imagePath );
						
						preferences.imagePref.value = userImage;
						preferences.namePref.value  = userImage;
						savePreferences();
						writePlist(spawnKonFile);
						
						saveAnchorPoint(bkgd);
						
						suppressUpdates();
						setMode(preferences.namePref.value);
						setImage(preferences.imagePref.value);
						setTooltip(preferences.namePref.value);
						resumeUpdates();
					}
					else { beep(); }
				}
			}
			else { beep(); }
			//delete dropData;
		}

		function getImageNames(dirName, recursive)
		{
			var files, i, iType;
			
			var path = resolvePath(dirName);
			var result = "";
			var s = "";
		
			if (filesystem.isDirectory(path))
			{
				files = filesystem.getDirectoryContents(path, recursive);
				for (i = 0; i < files.length; i += 1)
				{
					s = files[i];
					if (s.indexOf(path +'/') !== 0) { s = path + "/" + s; }
					iType = imageType(s);
					if (iType !== "")	// was if (isImage(s))
					{
						if ((displayType == '.all') || (displayType == iType))
						{
							if (result !== "") { result += listSep; }
							result += s;
						}
					}
				}
			}
			return result;
		}
		
		// eprint("section: " + (section++)); 
		
		function XcycleTime(cyclePref)
		{
			switch(cyclePref)
			{
				case "Never" : return 0;
				case "Every Five Seconds" : return 5;
				case "Every Fifteen Seconds" : return 15;
				case "Every Half Minute" : return 30;
				case "Every Minute" : return 60;
				case "Every Five Minutes" : return 300;
				case "Every Fifteen Minutes" : return 900;
				case "Every Half Hour" : return 1800;
				case "Every Hour" : return 3600;
				default: return 0;
			}
		}
		
		function changeImage(forward, force)
		{
			var slide, file, idx, userImage;
			
			if  ( (!force) && (!hasFocus) && (preferences.focusPref.value == "1") ) { return; }

			if ((slides.length > 0) && (theTimer.ticking || force))
			{
				if (preferences.modePref.value == "1")	// sequential slide show
				{
					if (forward)
					{
						gSlide = (gSlide + 1) % slides.length;
					}
					else
					{
						if (gSlide > 0) { gSlide -= 1; } else { gSlide = slides.length - 1; }
					}
				}
				else
				{
					if (forward)
					{
						gPrevSlide = gSlide;
						gSlide = Math.round((slides.length - 1) * Math.random());
					}
					else
					{
						if (gPrevSlide >= 0) { gSlide = gPrevSlide; } else { gSlide = Math.round((slides.length - 1) * Math.random()); }
					}
				}
				slide = gSlide;
				
				saveAnchorPoint(bkgd);
				
				file = slides[slide];
				
				if (filesystem.itemExists(file))	// user may have deleted the file
				{
					suppressUpdates();
					try
					{
						image.src = file;			// this might fail if image is defective
						
						idx = file.lastIndexOf('/');
						userImage = file.substring(idx+1);
						setMode(userImage);
						reSize(enlargedFlag);
					}
					catch(e)
					{
				
					}
					image.tooltip = "";
					resumeUpdates();
				}
			}
		}
		
		// widgetName should be the name of a spawned widget's kon file
		
		function writePlist(widgetName) {
				if (widgetName === "") { return; }	// original ancestor
				
			var fileName = spawnPath + '/' + widgetName + '.plist';
			
			var data = "";
				data += '<?xml version="1.0" encoding="UTF-8"?>\n';
				data += '<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">\n';
				data += '<plist version="1.0">\n';
				data += '<dict>\n';
				data += '\t<key>Pref-namePref</key>\n';
				data += '\t<string>' + preferences.namePref.value + '</string>\n';
				data += '</dict>\n';
				data += '</plist>\n';
				
			filesystem.writeFile(fileName, data);
		}
		
		function getPref(widgetName, key)
		{
			var found, string;
			
			var fileName = spawnPath + '/' + widgetName + '.plist';
			var data = filesystem.readFile(fileName);
			if (data === null) { return ""; }

			// <key>Pref-namePref</key>
			// <string>20031223.jpg</string>
		
			var start  = escapePath('<key>Pref-' + key + '</key>') + '\\s*?' + escapePath('<string>');
			var finish = escapePath('</string>');
			
			var lookFor = start + '([.\\s\\S]*?)' + finish;
		
			var pattern = new RegExp(lookFor);
			var result = data.match(pattern);
			if (result !== null)
			{
		        found  = result[0];		//eprint("found:  " + found);
		        string = result[1];		//eprint("string: " + string);
		        return string;
		    }
		    return "";
		}
		
		// used by original ancestor widget to list spawned widgets whose kon files exist
		
		function listSpawnedWidgets()
		{
			var konFile, i;
			
			var files = filesystem.getDirectoryContents(system.widgetDataFolder, false);

			var list = '';
			var n = 0;

			for (i = 0; i < files.length; i += 1) {
				konFile = files[i];
				if ( xtn(konFile) == ".kon")
				{
					if (n === 0) { list += konFile; } else { list += ',' + konFile; }
					n += 1;
				}
			}
			eprint('list=' + list);
			return list;
		}
		
		function esc(s) {
			var alfa = "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
			var t = "";
			for (var i = 0; i < s.length; i += 1) 	{
				if (alfa.indexOf(s[i]) >= 0) { t += s[i];}
				else if ((" " <= s[i]) && (s[i] < String.fromCharCode(127))) { t += "\\" + s[i]; }
				else { t += s[i]; }
			}
			return t;
		}
		
		function listActiveWidgets() {
			var lookFor, data, found;
			
			var psTable = getProcessTable();
			var activeList = "";
			for (var i = 0; i < psTable.length; i += 1) {
				lookFor = "";
				data = psTable[i];
				lookFor = '\\D*' + '(\\d+)' + '\\D.*?' + esc('/') + '([^\\/]+)' + esc('.kon ');
				found = data.match(lookFor);
				if (found !== null) { activeList += found[1] + ',' + found[2] + '.kon\n'; }
				else {
					lookFor = '\\D*' + '(\\d+)' + '\\D.*?' + esc('/') + '([^\\/]+)' + esc('.widget ');
					found = data.match(lookFor);
					if (found !== null) { activeList += found[1] + ',' + found[2] + '.widget\n'; }
				}
			}
			return activeList;
		}
				
		function getPID(widgetName, widgetTable) {
			var item;
			for (var i = 0; i < widgetTable.length; i += 1) {
				item = widgetTable[i].split(',');
				if (widgetName == item[1]) { return item[0]; }
			}
			return -1;
		}
		
		function closeSpawns()
		{
			if (systemPlatform != "macintosh") { return; }
			if (spawnKonFile !== "") { beep(); return; }
			
			var ls = listSpawnedWidgets();
			if (ls === "") { return; }
			var ps = listActiveWidgets();
			if (ps === "") { return; }
			var konFile = ls.split(',');
			var psTable = ps.split('\n');
			var pid;
			for (var i = 0; i < konFile.length; i += 1)
			{
				pid = getPID(konFile[i], psTable);
				killProcess(pid);
			}
		}
		
		function makeImageList()
		{
			var name, image;
			var wlist = listSpawnedWidgets();
			var files = wlist.split(',');
			var nlist = '';
			var n = 0;
			for (var i = 0; i < files.length; i += 1)
			{
				 name  = getPref(files[i], 'namePref');
				 image = name;	// getPref(files[i], 'imagePref');
				 if ((name !== "") && (image !== ""))
				 {
				 	if (image != name) { image = name + ' - ' + image; }
				 	if (n === 0) { nlist += image + ' == ' + files[i]; } else { nlist += ' || ' + image + ' == ' + files[i]; }
				 	n += 1;
				 }
			}
			return nlist;
		}

		function inOldRestartList(image, oldRestartList)
		{
			var item = image.split(' == ');
			if (oldRestartList.indexOf(item[1]) >= 0) { return 'Is Restarted'; }
			return 'Is Left Alone';
		}
		
		function XappFolderName()
		{
			return "Yahoo! Widget Engine";
		}
		
		function restartListForm(oldRestartList)
		{
			var imageItem, item, fileName, userHome, path;
			var imageList = makeImageList();
			
			if (imageList === "")
			{
				beep();
				alert(widgetName + ": This Widget has no spawns.");
				return "";
			}
			
			var imageArray = imageList.split(' || ');
			imageArray = imageArray.sort();
			var formfields = [];
		
			for (var i = 0; i < imageArray.length ; i += 1) {
				imageItem = imageArray[i].split(' == ');
				//var nameItem  = imageItem[0].split(' | ');
		
				formfields[i] = new FormField();
				//formfields[i].title = nameItem[0] + ':';
				
				formfields[i].title = imageItem[0] + ':';
				formfields[i].type = 'popup';
				formfields[i].option = [];
				formfields[i].option[0] = 'Is Restarted';
				formfields[i].option[1] = 'Is Left Alone';
				formfields[i].option[2] = 'Is Purged';
				formfields[i].defaultValue = inOldRestartList(imageArray[i], oldRestartList);
				formfields[i].description = imageItem[1];
			}
		
			var formResults = form(formfields, 'Spawn Management', 'OK');
			var result = '';
			var n = 0;
			
			if (formResults !== null) {
				for (i = 0; i < imageArray.length ; i += 1) {
					if (formResults[i] == 'Is Restarted') {
						item = imageArray[i].split(' == ');
						if (n === 0) { result += item[1]; } else { result += ',' + item[1]; }
						n += 1;
					} else if ( ( formResults[i] == 'Is Purged' ) ) {
							item = imageArray[i].split(' == ');
						fileName = item[1];
				
						if (systemPlatform == "macintosh")
						{
							userHome = resolvePath("~");
							path = userHome + "/Library/Preferences/Yahoo! Widget Engine/" + fileName + ".plist";
							filesystem.remove(path);
						}
						else
						{
							// clear out the equivalent data from the Windows registry
						}
						
						path = spawnPath + '/' + fileName + '.plist';
						filesystem.remove(path);

						path = spawnPath + '/' + fileName;
						filesystem.remove(path);
					}
				}
			} else {
				result = oldRestartList;
			}
		
			for (i = 0; i < imageArray.length ; i += 1) {
				delete formfields[i];
				formfields[i] = null;
			}
			
			return result;
		}
		
		function restartList() {
			if (spawnKonFile !== "") { beep(); return; }
			preferences.restartListPref.value = restartListForm(preferences.restartListPref.value);
			savePreferences();
		}

		function showButtons()
		{
			hasFocus = true;
			var i;
			var showFrame = (preferences.framePref.value == "0");
			if ((!scrollMode) || (!scrollBars)) { hsb.opacity = vsb.opacity = 0; }
			var showName  =  true;
			if (close.opacity === 0)
			{
				for (i = 31; i < 256; i += 32)
				{
					if (showFrame) 
					{
						lowerRight.opacity = lowerLeft.opacity = bottom.opacity = i;
						//reflectionLeft.opacity = reflectionMiddle.opacity = reflectionRight.opacity = i;
						lowerRightSmall.opacity = lowerLeftSmall.opacity = bottomSmall.opacity = 255 - i;
					}
					if (showName)   { status.opacity = statusShadow.opacity = i; }
					if (scrollMode && scrollBars) { hsb.opacity = vsb.opacity = i; }
					open.opacity = close.opacity = spawn.opacity = wrench.opacity = pause.opacity = back.opacity = forward.opacity = i;
					if (i < 255) { sleep(10); }
				}
			}
		}

		function hideButtons()
		{
			hasFocus = false;
			var i;
			var showFrame = (preferences.framePref.value == "0");
			if ((!scrollMode) || (!scrollBars)) { hsb.opacity = vsb.opacity = 0; }
			var showName  =  true;
			if (close.opacity !== 0)
			{
				for (i = 224; i >= 0; i -= 32)
				{
					if (showFrame) 
					{
						lowerRight.opacity = lowerLeft.opacity = bottom.opacity = i;
						//reflectionLeft.opacity = reflectionMiddle.opacity = reflectionRight.opacity = i;
						lowerRightSmall.opacity = lowerLeftSmall.opacity = bottomSmall.opacity = 255 - i;
					}
					if (showName)   { status.opacity = statusShadow.opacity = i; }
					if (scrollMode && scrollBars) { hsb.opacity = vsb.opacity = i; }
					open.opacity = close.opacity = spawn.opacity = wrench.opacity = pause.opacity = back.opacity = forward.opacity = i;
					if (i > 0) { sleep(10); }
				}
			}
		}

		// Code to spawn and delete widgets
		
		function startSpawnedWidgets() {	// used by original ancestor widget to relaunch selected spawned widgets
			var konFile, konPath;
			var ls = preferences.restartListPref.value;

			if (ls === "") { return; }
			var files = ls.split(',');
			for (var i = 0; i < files.length; i += 1)
			{
				konFile = files[i];
				eprint("Starting " + konFile);
				konPath = spawnPath + "/" + konFile;
				filesystem.openSpawn(konPath);
			}
		}

		function oldPrefs()	// get the parent's prefs - executed by the parent
		{
			var result = "";
			
			result += preferences.konfabulatorWindowLevel.value + "<pref-sep>";
			result += preferences.konfabulatorWindowOpacity.value + "<pref-sep>";
			
			result += preferences.widthPref.value + "<pref-sep>";	// depend on specific widget's .kon
			result += preferences.heightPref.value + "<pref-sep>";
			result += preferences.maxWidthPref.value + "<pref-sep>";
			result += preferences.maxHeightPref.value + "<pref-sep>";
			result += preferences.namePref.value + "<pref-sep>";
			result += preferences.imagePref.value + "<pref-sep>";
			result += preferences.rotationPref.value + "<pref-sep>";
			result += preferences.aspectRatioPref.value + "<pref-sep>";
			result += preferences.framePref.value + "<pref-sep>";
			result += preferences.timerPref.value + "<pref-sep>";
			result += preferences.folderPref.value + "<pref-sep>";
			result += preferences.cyclePref.value + "<pref-sep>";
			result += preferences.modePref.value + "<pref-sep>";
			result += preferences.anchorPref.value + "<pref-sep>";
			result += preferences.anchorXPref.value + "<pref-sep>";
			result += preferences.anchorYPref.value + "<pref-sep>";
			result += preferences.imageScalePref.value + "<pref-sep>";
			result += preferences.frameColor.value + "<pref-sep>";
			result += preferences.oversizePref.value + "<pref-sep>";
			result += preferences.subFolderPref.value + "<pref-sep>";
			result += preferences.imageMaskPref.value + "<pref-sep>";
			result += preferences.tooltipPref.value + "<pref-sep>";
			result += preferences.hideButtonsPref.value + "<pref-sep>";
			result += preferences.editorPref.value + "<pref-sep>";
			result += preferences.editorParamsPref.value + "<pref-sep>";
			result += preferences.detailsPref.value + "<pref-sep>";
			result += preferences.editorRevertPref.value + "<pref-sep>";
			result += preferences.thumbColor.value + "<pref-sep>";
			result += preferences.scrollModePref.value + "<pref-sep>";
			result += preferences.scrollBarsPref.value + "<pref-sep>";
			result += preferences.arrowsPref.value + "<pref-sep>";
			result += preferences.newSpawnPref.value;

			return result;
		}
		
		function newPrefs(theSpawnPos)	// set the child's prefs - executed by the child
		{
			preferences.konfabulatorWindowLevel.value = theSpawnPos[3];
			preferences.konfabulatorWindowOpacity.value = theSpawnPos[4];
			
			preferences.widthPref.value = theSpawnPos[5];
			preferences.heightPref.value = theSpawnPos[6];
			preferences.maxWidthPref.value = theSpawnPos[7];
			preferences.maxHeightPref.value = theSpawnPos[8];
			//preferences.namePref.value = theSpawnPos[9];	// keep default preference
			//preferences.imagePref.value = theSpawnPos[10];	// keep default preference
			preferences.rotationPref.value = theSpawnPos[11];
			preferences.aspectRatioPref.value = theSpawnPos[12];
			preferences.framePref.value = theSpawnPos[13];
			preferences.timerPref.value = theSpawnPos[14];
			preferences.folderPref.value = theSpawnPos[15];
			preferences.cyclePref.value = theSpawnPos[16];
			preferences.modePref.value = theSpawnPos[17];
			preferences.anchorPref.value = theSpawnPos[18];
			preferences.anchorXPref.value = theSpawnPos[19];
			preferences.anchorYPref.value = theSpawnPos[20];
			preferences.imageScalePref.value = theSpawnPos[21];
			preferences.frameColor.value = theSpawnPos[22];
			preferences.oversizePref.value = theSpawnPos[23];
			preferences.subFolderPref.value = theSpawnPos[24];
			preferences.imageMaskPref.value = theSpawnPos[25];
			preferences.tooltipPref.value = theSpawnPos[26];
			preferences.hideButtonsPref.value = theSpawnPos[27];
			preferences.editorPref.value = theSpawnPos[28];
			preferences.editorParamsPref.value = theSpawnPos[29];
			preferences.detailsPref.value = theSpawnPos[30];
			preferences.editorRevertPref.value = theSpawnPos[31];
			preferences.thumbColor.value = theSpawnPos[32];
			preferences.scrollModePref.value = theSpawnPos[33];
			preferences.scrollBarsPref.value = theSpawnPos[34];
			preferences.arrowsPref.value = theSpawnPos[35];
			preferences.newSpawnPref.value = theSpawnPos[36];

			if (preferences.newSpawnPref.value == "Are Restarted") { preferences.newSpawnPref.value = "Are Left Alone"; }
		}
		
		function escapeSingleQuotes(theStr)
		{
			var quote = "'", temp;
			var escapedQuote ="'\\''";
			
			//eprint("---" + escapedQuote + "---");
		  
		  	if (theStr.indexOf(quote) >=0)
		  	{
			  	temp ="";
		  		for (count = 0; count < theStr.length; count += 1)
		  		{
		  			if (theStr[count] != quote)
		  			{
		  				temp += theStr[count];
		  			}
		  			else
		  			{
		  				temp += escapedQuote;
		  			}
		  		}
		  		return temp;
			}
		  	else
		  	{
		  		return theStr;
		  	}
		}

		function escapeSpaces(theStr)
		{
			var space = " ", temp;
			var escapedSpace ="\\ ";
			
			//eprint("---" + escapedSpace + "---");
		  
		  	if (theStr.indexOf(space) >=0)
		  	{
			  	temp ="";
		  		for (count = 0; count < theStr.length; count += 1)
		  		{
		  			if (theStr[count] != space)
		  			{
		  				temp += theStr[count];
		  			}
		  			else
		  			{
		  				temp += escapedSpace;
		  			}
		  		}
		  		return temp;
			}
		  	else
		  	{
		  		return theStr;
		  	}
		}

		function spawnNewWidget() {	// allows nine children 1..9  - executed by the parent
			if (children >= 9) { beep(); return; }
			children += 1;
			
			var konFile = widgetName + children + ".kon";
			var konPath = spawnPath + "/" + konFile;
	
			if (filesystem.itemExists(konPath))
			{
				eprint("Starting " + konFile);
				filesystem.openSpawn(konPath);
				return;
			}

			eprint("Spawning:" + konFile);
			
			var newHoffset = Number(main_window.hOffset + 108) % screen.availWidth;
			var newVoffset = Number(main_window.vOffset + 54) % screen.availHeight;
			
			var fileContent = "";
			fileContent += newHoffset + "<pref-sep>";
			fileContent += newVoffset + "<pref-sep>";
			fileContent += konFile + "<pref-sep>";
			fileContent += oldPrefs();
			
			filesystem.writeFile(spawnPath + "/spawnPos.txt", fileContent);
			filesystem.copy(resPath + "/Spawns/spawnTMPL.kon", konPath);

			eprint("Starting " + konFile);
			filesystem.openSpawn(konPath);
		}
		
		function deleteKonFile()	{ // called on Unload of spawned widget
			eprint("Deleting:" + spawnKonFile);
			filesystem.remove(spawnKonFile);
			//sleep(3000);	// enable to see the debug info
		}

		function saveOldImage()
		{
			var imageFile, tempDir;
			var userImage = preferences.imagePref.value;
			
			if (userImage != "defaultImage.png")
			{
				imageFile = system.widgetDataFolder + '/' + userImage;
				
				if (filesystem.itemExists(imageFile))
				{
					tempDir = system.temporaryFolder + '/' + widgetName;
					filesystem.createDirectory(tempDir);
					filesystem.copy(imageFile, tempDir);
				}
			}
		}
		
		// eprint("section: " + (section++)); 
		
		function restoreOldImage()
		{
			var tempDir, tempFile, imageDir;
			var userImage = preferences.imagePref.value;
			
			if (userImage != "defaultImage.png")
			{
				tempDir  = system.temporaryFolder + '/' + widgetName;
				tempFile = tempDir + '/' + userImage;
		
				if (filesystem.itemExists(tempFile))
				{
					imageDir = system.widgetDataFolder;
					filesystem.move(tempFile, imageDir);
					filesystem.remove(tempDir);
				}
			}
		}
		
///////////////////////////////// scrolling and rotation controls //////////////////////////////////

bkgd.onMouseDown  = function ()
{
	saveAnchorPoint(bkgd);
	altKey = system.event.altKey;
	if (navArrows) { if (altKey) { rimg.visible = true; } else if (scrollMode) { mimg.visible = true; } }
	downX   = system.event.x;
	downY   = system.event.y;
	scrollX = hsb.value;
	scrollY = vsb.value;
	downRotation = main_frame.rotation;
	downAngle = (Math.atan2((main_window.height / 2) - system.event.vOffset, (main_window.width / 2) - system.event.hOffset)/Math.PI) * 180;
};

bkgd.onMouseDrag  = function ()
{
	if (altKey)
	{
		var angle = (Math.atan2((main_window.height / 2) - system.event.vOffset, (main_window.width / 2) - system.event.hOffset)/Math.PI) * 180;
		var rotation = Math.round( (downRotation + (angle - downAngle)) % 360);
		preferences.rotationPref.value = String(rotation);
		reSize(enlargedFlag);
		return;
	}
	var newScrollX = scrollX - (system.event.x - downX);
	var newScrollY = scrollY - (system.event.y - downY);
	hsb.value = newScrollX;
	vsb.value = newScrollY;
};

bkgd.onMouseUp = function () { rimg.visible = mimg.visible = false; };

rimg.visible = mimg.visible = false;

//////////// end //////////////// scrolling and rotation controls //////////////////////////////////


		// Code to find out whether this is an original widget or a spawned widget
		
		//PATH=.../WidgetName.widget/Contents			-- original widget
		
		lprint('------ Starting environment code ------');

		var PATH = resolvePath(".");
		lprint('PATH=' + PATH);

		var ix = PATH.lastIndexOf("/");
		var folder = PATH.substring(ix+1); // "Contents" or "Spawns"
		lprint('folder=' + folder);

		var idx, temp, idxKon;
		if (folder == "Contents"){					// this is an original widget

			lprint('------ this is an original widget ------');

			resPath = resolvePath(".");				// Resource path for original widget
			lprint('resPath=' + resPath);
			
			spawnPath = system.widgetDataFolder;	// Path to spawned .kon files
			lprint('spawnPath=' + spawnPath);

			//spawnResPath = PATH;
			spawnResPath = resolvePath(".");
			lprint('spawnResPath=' + spawnResPath);

			idx = PATH.lastIndexOf(".widget/Contents");
			temp = PATH.substring(0,idx);
			idx = temp.lastIndexOf("/");
			widgetName = temp.substring(idx+1);

			if (versionPref != preferences.versionPref.value)	
			{			
				preferences.versionPref.value = versionPref;
				preferences.restartListPref.value = "";
				closeSpawns();
				saveOldImage();
				filesystem.remove(system.widgetDataFolder);
			}

			if (! filesystem.itemExists(system.widgetDataFolder + "/Resources/main.js"))
			{
				filesystem.copy("Resources", system.widgetDataFolder);
				filesystem.copy("Spawns",    system.widgetDataFolder);
				filesystem.copy("widget.xml",    system.widgetDataFolder);
				restoreOldImage();
			}

			if (systemPlatform == "macintosh") { spawn.tooltip += "  Hold down the option key and click to manage your spawned widgets."; }
			if (systemPlatform == "windows")   { spawn.tooltip += "  Hold down the alt key and click to manage your spawned widgets."; }
			if (systemPlatform == "macintosh") { close.tooltip += "  Hold down the option key and click to close the spawned widgets."; }

			if (preferences.newSpawnPref.value == "Are Restarted") { startSpawnedWidgets(); }	// start any children with kon files
			spawnKonFile = "";	// empty in the case of the original ancestor
		} else {
		
			lprint('------ this is a spawned widget ------');
			
			//resPath = preferences.resPathPref.value;
			resPath = resolvePath(".");
			lprint('resPath='+ resPath);

			spawnPath = resolvePath(".");
			lprint('spawnPath='+ spawnPath);
			
			//spawnResPath = resPath;
			spawnResPath = resolvePath(".");
			lprint('spawnResPath='+ spawnResPath);

			if (preferences.newChildPref.value != "0") {								// first run of this spawned widget ?
				theSpawnPos = filesystem.readFile("spawnPos.txt").split("<pref-sep>");	// read the file written by the parent widget
				main_window.hOffset = theSpawnPos[0];
				main_window.vOffset = theSpawnPos[1];
				preferences.spawnKonFilePref.value = theSpawnPos[2];				// save the konFile Name
				newPrefs(theSpawnPos);												// set the child's prefs as copy of parents
				preferences.newChildPref.value = "0";								// child now has its own prefs
				savePreferences();
			}
			spawnKonFile = preferences.spawnKonFilePref.value;		// find our own .kon file
			lprint("spawnKonFile=" + spawnKonFile);
			idxKon = spawnKonFile.lastIndexOf(".kon");
			widgetName = spawnKonFile.substring(0,idxKon);			// find out our own name
			writePlist(spawnKonFile);
		}
		lprint(widgetName + " has started.");

		// End of code to spawn and delete widgets
		
		if (systemPlatform == "macintosh") { wrench.tooltip += "  Option-click to delete the displayed image."; }
		if (systemPlatform == "windows")   { wrench.tooltip += "  Alt-click to delete the displayed image."; }
		
		preferences.editorParamsPref.hidden = (systemPlatform == "macintosh");
		if (systemPlatform == "macintosh") { preferences.editorParamsPref.value = ""; }

		var startTimer = new Timer();

		function startTimerFired()
		{
			startTimer.ticking=false;
			updatePrefs(false);
			//reSize(false);
			main_window.visible = true;
			//reSize(false);
			focusWidget();
			if (preferences.hideButtonsPref.value == '1') { hideButtons(); }
		}

		startTimer.ticking=false;
		startTimer.interval = 1;
		startTimer.onTimerFired = "startTimerFired();";
		startTimer.ticking=true;
