// ImageView  - version .6
// WebImages  - version 3.8.2
// Scraper    - version 1.5
// 26 July, 2009
// Written by Harry Whitfield (g6auc@arrl.net)
// Interface by Ricky Romero (rlr@ricky-romero.com)
// Code and Images Copyright 2004-2009 by Harry Whitfield and Ricky Romero
// Widget spawning code is based on code by Arlo Rose.

/*global addMouseUp, closeSpawns, deleteSlide, dragDropped, eprint, nextSlide, onMouseOver, onPause,
		 onWrench, openMouseUp, openSlide, optionKeyDown, pauseSlideShow, prevSlide, quickMenu,
		 quitAllMediaPlayers, restartList, setMediaVolume, spawnNewWidget, statusMouseup,
		 toggleMediaPaused, toggleVolumeMuted, main_window
*/

/*members alignment, appendChild, bgColor, bgOpacity, checked, color, 
    colorize, contextMenuItems, data, editable, enabled, event, font, 
    hAlign, hOffset, hScrollBar, height, indexOf, level, modifiers, name, 
    onDragDrop, onDragEnter, onDragExit, onMouseDown, onMouseEnter, 
    onMouseExit, onMouseUp, onSelect, opacity, open, orientation, push, 
    reveal, scrollbar, shadow, size, src, style, thumbColor, title, tooltip, 
    vAlign, vOffset, vScrollBar, visible, width
*/

var rbase = "Resources/Images/";

var the_parent  = null;
//var main_window = null;	// now set in the .kon file
var main_frame  = null;
var bkgd  		= null;
var frame       = null;
var image 		= null;
var main_image	= null;
var hsb         = null;
var vsb         = null;
var report		= null;
var rimg        = null;
var mimg        = null;
var buttonKey	= "";

var add			= null;
var open		= null;
var wrench		= null;
var back		= null;
var pause		= null;
var sPause		= null;
var forward		= null;
var close		= null;
var spawn		= null;
var statusShadow= null;
var status		= null;

function newWindow(title, hOffset, vOffset, width, height, alignment, level, shadow, visible)
{
	var o = new Window();
	o.title     = title;
	o.width     = width;
	o.height    = height;
	o.alignment = alignment;
	o.hOffset   = hOffset;
	o.vOffset   = vOffset;
	o.level     = level;
	o.shadow    = shadow;
	o.visible   = visible;
	return o;
}

function newFrame(parent, hOffset, vOffset, width, height, hAlign)
{
	var o = new Frame();
	o.hOffset = hOffset;
	o.vOffset = vOffset;
	o.width   = width;
	o.height  = height;
	o.hAlign  = hAlign;
	parent.appendChild( o );
	return o;
}

function newScrollBar(parent, orientation, hOffset, vOffset, width, height, hAlign, opacity, thumbColor)
{
	var o = new ScrollBar();
	o.orientation = orientation;
	o.hOffset     = hOffset;
	o.vOffset     = vOffset;
	o.width       = width;
	o.height      = height;
	o.hAlign      = hAlign;
	o.opacity     = opacity;
	o.thumbColor = thumbColor;
	parent.appendChild( o );
	return o;
}

function newImage(parent, src, hOffset, vOffset, width, height, hAlign, opacity, colorize)
{
	var o = new Image();
	o.src      = src;
	o.hOffset  = hOffset;
	o.vOffset  = vOffset;
	o.width    = width;
	o.height   = height;
	o.hAlign   = hAlign;
	o.opacity  = opacity;
	o.colorize = colorize;
	parent.appendChild( o );
	return o;
}

function newText(parent, hOffset, vOffset, width, height, hAlign, font, style, size, color, opacity, bgColor, bgOpacity)
{
	var o = new Text();
	o.hOffset   = hOffset;
	o.vOffset   = vOffset;
	o.width     = width;
	o.height    = height;
	o.hAlign    = hAlign;
	o.font      = font;
	o.style     = style;
	o.size      = size;
	o.color     = color;
	o.opacity   = opacity;
	o.bgColor   = bgColor;
	o.bgOpacity = bgOpacity;
	parent.appendChild( o );
	return o;
}

function newTextArea(parent, hOffset, vOffset, width, height, hAlign, font, style, size, color, opacity, bgColor, bgOpacity, scrollbar, editable)
{
	var o = new TextArea();
	o.hOffset   = hOffset;
	o.vOffset   = vOffset;
	o.width     = width;
	o.height    = height;
	o.hAlign    = hAlign;
	o.font      = font;
	o.style     = style;
	o.size      = size;
	o.color     = color;
	o.opacity   = opacity;
	o.bgColor   = bgColor;
	o.bgOpacity = bgOpacity;
	o.scrollbar = scrollbar;
	o.editable  = editable;
	parent.appendChild( o );
	return o;
}

function newContextMenuItem(title, onSelect, enabled, checked)
{
	var o = new MenuItem();
	o.title    = title;
	o.onSelect = onSelect;
	o.enabled  = enabled;
	o.checked  = checked;
	return o;
}

function addDragHandlers(o, onDragEnter, onDragDrop, onDragExit)
{
	o.onDragEnter = onDragEnter;
	o.onDragDrop  = onDragDrop;
	o.onDragExit  = onDragExit;
}

function addMouseWithinHandlers(o, onMouseEnter, onMouseExit)
{
	o.onMouseEnter = onMouseEnter;
	o.onMouseExit  = onMouseExit;
}

function addMouseHandlers(o, onMouseDown, onMouseUp)
{
	o.onMouseDown = onMouseDown;
	o.onMouseUp  = onMouseUp;
}

////////////////////////////////////////// 

function onClose()
{
	close.opacity=255;
	if (optionKeyDown(system.event.modifiers)) { closeSpawns(); } else { closeWidget(); }
}

function onSpawn()
{
	spawn.opacity=255;
	if (optionKeyDown(system.event.modifiers)) { restartList(); } else { spawnNewWidget(); }
}

function myPauseSlideShow()	{ sPause.opacity  = 255; pauseSlideShow(); }
function myNextSlide()		{ forward.opacity = 255; nextSlide();      }
function myPrevSlide()		{ back.opacity    = 255; prevSlide();      }
function myAddMouseUp()		{ add.opacity     = 255; addMouseUp();     }
function myOpenMouseUp()	{ open.opacity    = 255; openMouseUp();    }
function myOnWrench()		{ wrench.opacity  = 255; onWrench();       }
function myOnPause()		{ pause.opacity   = 255; onPause();        }
function myStatusMouseup()	{ status.opacity  = 255; statusMouseup();  }

function myOpenSlide()		{ openSlide(image.src); 				   }
function myFileSysReveal()	{ filesystem.reveal(image.src); 		   }
function myDeleteSlide()	{ deleteSlide(image.src); 				   }
function myDisplayHelp()	{ filesystem.open('Resources/Help.pdf');   }

function opacity128() 		{ image.opacity = 128; }
function opacity255() 		{ image.opacity = 255; }
function dragDroppedImage() { dragDropped(image);  }

function onMouseOverTrue()  { onMouseOver(true);  }
function onMouseOverFalse() { onMouseOver(false); }

function buttonOpacity127()	{ this.opacity = 127; }

function forwardSetMediaVolume()      { setMediaVolume();      }
function forwardToggleVolumeMuted()   { toggleVolumeMuted();   }
function forwardToggleMediaPaused()   { toggleMediaPaused();   }
function forwardQuitAllMediaPlayers() { quitAllMediaPlayers(); }


var theWidgetName = widget.name;
eprint("theWidgetName=" + theWidgetName);

     if (theWidgetName.indexOf("ImageView")  === 0) { theWidgetName = "ImageView"; }
else if (theWidgetName.indexOf("WebImages")  === 0) { theWidgetName = "WebImages"; }
else if (theWidgetName.indexOf("Scraper")    === 0) { theWidgetName = "Scraper";   }
else { beep(); alert('Invalid Widget Name: ' + theWidgetName); closeWidget();     }

if (theWidgetName == "ImageView")
{
//	main_window 	= newWindow("ImageView", 72, 36, 349, 300, "left", "normal", false, false);	// now set in the .kon file
	main_frame      = newFrame(main_window, 13, 10, 320, 240, "left");
	bkgd 			= newImage(main_frame, rbase + "bkgd.png", 0, 0, 320, 240, "left", 255, "#FFFFFF");
	frame           = newFrame(main_frame, 0, 0, 320, 240, "left");
	image 			= newImage(frame, rbase + "defaultImage.png", 0, 0, 320, 240, "left", 255, null);	

	rimg 			= newImage(main_window, rbase + "rimg.png", 160, 128, 48, 48, "center", 255, null);
	mimg 			= newImage(main_window, rbase + "mimg.png", 160, 128, 48, 48, "center", 255, null);
	rimg.vAlign = "center"; rimg.visible = "false"; mimg.vAlign = "center"; rimg.visible = "false";
	
	hsb             = newScrollBar(main_frame, "horizontal", 0, 225, 320,  15, "left", 255, "#da930a");	// "#da930a"
	vsb             = newScrollBar(main_frame, "vertical",   315, 0, 15, 215, "left", 255, "#da930a");	// "#da930a"
	frame.hScrollBar = hsb;
	frame.vScrollBar = vsb;

	image.tooltip 	= "To change the view, drag an image onto me.";
	addDragHandlers(image, opacity128, dragDroppedImage, opacity255);
	addMouseWithinHandlers(image, onMouseOverTrue, onMouseOverFalse);
	buttonKey 		= "owbpfcs";
	the_parent      = main_frame;
}
else if (theWidgetName == "WebImages")
{
	main_window 	= newWindow("WebImages", 72, 36, 349, 300, "left", "normal", false, false);
	main_frame      = newFrame(main_window, 13, 10, 320, 240, "left");
	bkgd 			= newImage(main_frame, rbase + "bkgd.png", 0, 0, 320, 240, "left", 0, "#FFFFFF");
	frame           = newFrame(main_frame, 0, 0, 320, 240, "left");
//	bgImage 		= newImage(frame, rbase + "bkgd.png",    0, 0, 320, 240, "left",   0, null);
	image 			= newImage(frame, rbase + "Loading.png", 0, 0, 320, 240, "left", 255, null);

	rimg 			= newImage(main_window, rbase + "rimg.png", 160, 128, 48, 48, "center", 255, null);
	mimg 			= newImage(main_window, rbase + "mimg.png", 160, 128, 48, 48, "center", 255, null);
	rimg.vAlign = "center"; rimg.visible = "false"; mimg.vAlign = "center"; rimg.visible = "false";
	
	hsb             = newScrollBar(main_frame, "horizontal", 0, 225, 320,  15, "left", 255, "#da930a");	// "#da930a"
	vsb             = newScrollBar(main_frame, "vertical",   315, 0, 15, 215, "left", 255, "#da930a");	// "#da930a"
	frame.hScrollBar = hsb;
	frame.vScrollBar = vsb;

	addMouseWithinHandlers(image, onMouseOverTrue, onMouseOverFalse);
	report 			= newTextArea(frame, 0, 0, 320, 240, "left", "Courier New", "font-weight: normal;", 12, "#000000", 0, "#FFFFFF", 0, false, false);
	addMouseWithinHandlers(report, onMouseOverTrue, onMouseOverFalse);
	buttonKey = "aowpfcs";
	quickMenu 		= newImage(main_frame, rbase + "quickMenu.png", 8, 8, 72, 20, "left", 255, null);
	the_parent      = main_frame;
}
else if (theWidgetName == "Scraper")
{
//	main_window 	= newWindow("Scraper", 72, 36, 349, 705, "left", "normal", false, false);	// now set in the .kon file
	main_frame      = null;
	bkgd			= null;
	frame 			= null;
	image 			= newImage(main_window, rbase + "Loading.png", 14, 10, 320, 240, "left", 255, null);
	hsb				= null;
	vsb				= null;
	addMouseWithinHandlers(image, onMouseOverTrue, onMouseOverFalse);
	report 			= newTextArea(main_window, 14, 10, 320, 240, "left", "Courier New", "font-weight: bold;", 12, "#000000", 255, "#93B9B0", 255, false, false);
	addMouseWithinHandlers(report, onMouseOverTrue, onMouseOverFalse);
	buttonKey = "aowpfcs";
	the_parent      = main_window;
}

var upperLeft 		= newImage(the_parent, rbase + "ULeft.png",    0,    0,  21,  22, "left",  255, "#000000");
var top 			= newImage(the_parent, rbase + "Top.png",      21,   0, 307,  22, "left",  255, "#000000");
var upperRight 		= newImage(the_parent, rbase + "URight.png",  328,   0,  21,  22, "left",  255, "#000000");
var rightSide 		= newImage(the_parent, rbase + "RSide.png",   328,  22,  21, 222, "left",  255, "#000000");
var lowerRight 		= newImage(the_parent, rbase + "LRight.png",  328, 244,  21,  35, "left",  255, "#000000");
var bottom 			= newImage(the_parent, rbase + "Bottom.png",   21, 244, 307,  35, "left",  255, "#000000");
var lowerLeft 		= newImage(the_parent, rbase + "LLeft.png",     0, 244,  21,  35, "left",  255, "#000000");
var leftSide 		= newImage(the_parent, rbase + "LSide.png",     0, 22,   21, 222, "left",  255, "#000000");
var lowerRightSmall = newImage(the_parent, rbase + "LRSmall.png", 328, 244,  21,  22, "left",    0, "#000000");
var bottomSmall 	= newImage(the_parent, rbase + "BSmall.png",   21, 244, 305,  22, "left",    0, "#000000");
var lowerLeftSmall	= newImage(the_parent, rbase + "LLSmall.png",   0, 244,  21,  22, "left",    0, "#000000");
		
var offset = 22;	// left hand side

if (buttonKey.indexOf("a") >= 0)
{
	add				= newImage(the_parent, rbase + "Add.png", 		offset, 250,  20,  17, "left",  255, null);
	add.tooltip		= "Add a new location to the directory of locations.";
	addMouseHandlers(add, buttonOpacity127, myAddMouseUp);
	offset += 20;
}

if (buttonKey.indexOf("o") >= 0)
{
	open			= newImage(the_parent, rbase + "MagLens.png", 	offset, 250,  20,  17, "left",  255, null);
	open.tooltip	= "Enlarge (or restore) the size of the image.";
	addMouseHandlers(open, buttonOpacity127, myOpenMouseUp);
	offset += 20;
}

if (buttonKey.indexOf("w") >= 0)
{
	wrench			= newImage(the_parent, rbase + "Wrench.png", 	offset, 250,  21,  17, "left",  255, null);
	wrench.tooltip	= "Open the displayed image. Shift-click to find the displayed image.";
	addMouseHandlers(wrench, buttonOpacity127, myOnWrench);
	offset += 20;
}

if (buttonKey.indexOf("b") >= 0)
{
	back			= newImage(the_parent, rbase + "Back.png", 	offset, 250,  21,  17, "left",  255, null);
	back.tooltip	= "Go to the previous slide.";
	addMouseHandlers(back, buttonOpacity127, myPrevSlide);
	offset += 20;
}

if (buttonKey.indexOf("p") >= 0)
{
	pause			= newImage(the_parent, rbase + "Pause.png", 	offset, 250,  21,  17, "left",  255, null);
	pause.tooltip	= "Pause (or continue) the slide show.";
	addMouseHandlers(pause, buttonOpacity127, myOnPause);
	offset += 20;
}

offset = 247;	// right hand side

if (buttonKey.indexOf("q") >= 0)
{
	sPause			= newImage(the_parent, rbase + "Pause.png", 	offset, 250,  21,  17, "left",  255, null);
	sPause.tooltip	= "Pause (or continue) the slide show.";
	addMouseHandlers(sPause, buttonOpacity127, myPauseSlideShow);
}
offset = 267;

if (buttonKey.indexOf("f") >= 0)
{
	forward			= newImage(the_parent, rbase + "Forward.png", 	offset, 250,  20,  17, "left",  255, null);
	forward.tooltip	= "Go to the next slide.";
	addMouseHandlers(forward, buttonOpacity127, myNextSlide);
	offset += 20;
}

if (buttonKey.indexOf("c") >= 0)
{
	close			= newImage(the_parent, rbase + "Close.png", 	offset, 250,  20,  17, "left",  255, null);
	close.tooltip	= "Close this instance of " + theWidgetName + ".";
	addMouseHandlers(close, buttonOpacity127, onClose);
	offset += 20;
}
	
if (buttonKey.indexOf("s") >= 0)
{
	spawn			= newImage(the_parent, rbase + "NewSpawn.png", offset, 250,  21,  17, "left",  255, null);
	spawn.tooltip	= "Spawn a new instance of " + theWidgetName + ".";
	addMouseHandlers(spawn, buttonOpacity127, onSpawn);
	offset += 20;
}

statusShadow	= newText(the_parent, 174, 260, null, null, "center", "Futura Medium", "font-weight: normal;", 9, "#000000", 255, "#000000", 0);
statusShadow.data = "";

status			= newText(the_parent, 174, 260, null, null, "center", "Futura Medium", "font-weight: normal;", 9, "#FFFFFF", 255, "#FFFFFF", 0);
	status.data = "";

var m;
var contextMenuItems = [];	

if (theWidgetName == "ImageView")
{
	wrench.tooltip	= "Open the displayed image. Shift-click to find the displayed image.";
	pause.tooltip	= "Pause (or continue) the slide show.";
	back.tooltip	= "Go to the previous slide. Alt-click for slower updating.";
	forward.tooltip	= "Go to the next slide. Alt-click for faster updating.";

	m = newContextMenuItem("Next Slide", myNextSlide, false, false);
	contextMenuItems.push(m);

	m = newContextMenuItem("Previous Slide", myPrevSlide, false, false);
	contextMenuItems.push(m);

	m = newContextMenuItem("Open Current Slide", myOpenSlide, false, false);
	contextMenuItems.push(m);

	m = newContextMenuItem("Find Current Slide", myFileSysReveal, false, false);
	contextMenuItems.push(m);

	 m = newContextMenuItem("Delete Current Slide", myDeleteSlide, false, false);
	contextMenuItems.push(m);

	m = newContextMenuItem("-", "", false, false);
	contextMenuItems.push(m);
}
else if (theWidgetName == "WebImages")
{
	wrench.tooltip	= "Delete a location from the directory of locations.";
	pause.tooltip	= "Pause timed updating of the image.";
	forward.tooltip	= "Update the image.";
	addMouseHandlers(status, buttonOpacity127, myStatusMouseup);
	
	m = newContextMenuItem("Set Media Player Volume...", forwardSetMediaVolume, true, false);
	contextMenuItems.push(m);

	m = newContextMenuItem("Mute/Restore Media Player Volume", forwardToggleVolumeMuted, true, false);
	contextMenuItems.push(m);

	m = newContextMenuItem("Pause/Play Media Player", forwardToggleMediaPaused, true, false);
	contextMenuItems.push(m);

	m = newContextMenuItem("Close Media Players", forwardQuitAllMediaPlayers, true, false);
	contextMenuItems.push(m);

	m = newContextMenuItem("-", "", false, false);
	contextMenuItems.push(m);
}
else if (theWidgetName == "Scraper")
{
	open.tooltip	= "Enlarge (or restore) the size of the window.";
	wrench.tooltip	= "Delete a location from the directory of locations.";
	pause.tooltip	= "Pause timed updating of the window.";
	forward.tooltip	= "Update the window.";
	addMouseHandlers(status, buttonOpacity127, myStatusMouseup);
}

m = newContextMenuItem("Display Help File...", myDisplayHelp, true, false);
contextMenuItems.push(m);

main_window.contextMenuItems = contextMenuItems;
