/*	
	ImageView - version 2.4
	31 December, 2008
	Written by Harry Whitfield (g6auc@arrl.net)
	Interface by Ricky Romero (rlr@ricky-romero.com)
	Code and Images Copyright 2004-2008 by Harry Whitfield and Ricky Romero
	Widget spawning code is based on code by Arlo Rose.
	Thanks go to Cicerone Pavaloi for help in improving the scrolling and rotation code.
*/

/*global eprint, lprint, systemPlatform
*/

/*members createDirectory, makeDirectory, open, openFileInApplication, 
    openSpawn, remove, replace, split, unixRM
*/

var bgResult = "";

function doCommand(command)
{
	lprint('command: ' + command);
	var result = runCommand(command);
	lprint('result:  ' + result);
	return result;
}

function escapePath(path) { return path.replace(/([\W])/g,'\\$1'); }

// calls used only on the Macintosh - never have been in Unix Utils
function getFileInfo(path) { return doCommand('file ' + escapePath(path)); }
function getProcessTable() { return doCommand('ps -xww').split('\n'); }
function killProcess(pid)  { if (pid >= 0) { doCommand('kill ' + pid); } }

filesystem.makeDirectory = function(path) { return filesystem.createDirectory(path); };
filesystem.unixRM = function(path)  { return filesystem.remove(path); };

function quotePath(path)
{
	path = path.replace(/\//g, "\\");		// replace slash by back-slash
	path = path.replace(/\\/g, "\\\\");		// escape back-slash
	path = path.replace(/\"/g, "\\\"");		// escape double-quote
	path = "\"" + path + "\"";				// double-quote the path
	return path;
}

filesystem.openFileInApplication = function (application, file, params) {
	var command, result;

	eprint('application: ' + application);
	if (file)   {
		eprint('file:        ' + file);
	}
	if (params) {
		eprint('params:      ' + params);
	}

	if (systemPlatform == "macintosh") {
		command = 'open -a ' + escapePath(application) + ' ' + escapePath(file);
		eprint('openFileInApplication:command: ' + command);
		result  = runCommand(command);
		eprint('openFileInApplication:result:  ' + result);
	} else {
		if (params) {
			params = ' ' + params;
		} else {
			params = "";
		}
		if (file)   {
			file   = ' ' + quotePath(file);
		} else {
			file   = "";
		}
		command = quotePath(application) + params + file;
		eprint('openFileInApplication:bgCommand: ' + command);
		runCommandInBg(command, "bgResult");
	}
};

filesystem.openSpawn = function(path)
{
	var application = "Yahoo! Widget Engine.app";
	if ( parseFloat(konfabulatorVersion()) >= 4.5) { application = "Yahoo! Widgets.app"; }

	if (systemPlatform == "macintosh")
	{
		filesystem.openFileInApplication(application, path, "");
	}
	else
	{
		filesystem.open(path);
	}
};
